function varargout = data_acquisition(varargin)
% DATA_ACQUISITION MATLAB code for data_acquisition.fig
%      DATA_ACQUISITION, by itself, creates a new DATA_ACQUISITION or raises the existing
%      singleton*.
%
%      H = DATA_ACQUISITION returns the handle to a new DATA_ACQUISITION or the handle to
%      the existing singleton*.
%
%      DATA_ACQUISITION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DATA_ACQUISITION.M with the given input arguments.
%
%      DATA_ACQUISITION('Property','Value',...) creates a new DATA_ACQUISITION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before data_acquisition_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to data_acquisition_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help data_acquisition
% Created by I. B. de Paula, PUC-Rio 2017
% Last Modified by GUIDE v2.5 05-Sep-2017 16:42:30

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @data_acquisition_OpeningFcn, ...
                   'gui_OutputFcn',  @data_acquisition_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before data_acquisition is made visible.
function data_acquisition_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to data_acquisition (see VARARGIN)

% Choose default command line output for data_acquisition
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes data_acquisition wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = data_acquisition_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function analysis_CreateFcn(hObject, eventdata, handles)
% hObject    handle to analysis (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function nbits_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nbits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function nsamples_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nsamples (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function sampl_rate_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sampl_rate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function range_CreateFcn(hObject, eventdata, handles)
% hObject    handle to range (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in acquire.
function acquire_Callback(hObject, eventdata, handles)
% hObject    handle to acquire (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
nsamples=str2num(get(handles.nsamples,'String'));
sampl_rate=str2num(get(handles.sampl_rate,'String'));
period=nsamples*sampl_rate;

range=get(handles.range,'Value');
if range==1
    gain=1;
    ampl_range=10;
elseif range==2
    gain=2;
    ampl_range=5;
else 
    gain=10;
    ampl_range=1;
end

if evalin('base','exist(''waveform'')')==0
    h2=msgbox('No signal available. Please generate a waveform using the tool "waveform_gen.m"');
else
    signal=evalin('base','waveform');
    time=evalin('base','time');
    dt=time(2)-time(1);
    step_t=floor((1/dt)/sampl_rate); % multiple of waveform sampling frequency in waveform_gen.m
    sampl_rate=1/(dt*step_t);
    set(handles.sampl_rate,'String',num2str(sampl_rate));
    % apply gain related to range
    signal=signal*gain+1e-3*randn(1);
    bits=str2num(get(handles.nbits,'String'));
    % signal discrete in amplitude
    %signal=round(signal/(20/(2^bits)))*(20/(2^bits))/gain;
    
    % signal discrete in time
    nsamples_waveform=length(time);
    for i=1:nsamples
        signal_acquired(i)=signal(rem((i-1)*step_t,nsamples_waveform-1)+1);
        signal_acquired(i)=round(signal_acquired(i)/(20/(2^bits))+(randn(1)-0.5))*(20/(2^bits))/gain;
        time_acq(i)=time(rem((i-1)*step_t,nsamples_waveform-1)+1)+floor(((i-1)*step_t)/(nsamples_waveform-1))*(time(end)-time(1));
    end
    nonconditioned=get(handles.nonconditioned,'Value');
    if nonconditioned==1
        if evalin('base','exist(''waveform_original'')')==0
            h2=msgbox('Signal not conditioned. Nonconditioned signal shown in the figure');
            set(handles.nonconditioned,'Value',0);
            pause(0.5);
        else
            signal_original=evalin('base','waveform_original');
            for i=1:nsamples
                signal_acquired_original(i)=(signal_original(rem((i-1)*step_t,nsamples_waveform-1)+1))*gain;
                signal_acquired_original(i)=round(signal_acquired_original(i)/(20/(2^bits))+(randn(1)-0.5))*(20/(2^bits))/gain;
            end
        end
    end
        
    analysis=get(handles.analysis,'Value');
    if analysis==1
        set(handles.text6,'String', 'Time (s)'); 
        set(handles.axes1,'yscale','linear');
        plot(time_acq,signal_acquired,'-b','parent',handles.axes1);
        set(handles.axes1,'ylim',[-ampl_range ampl_range]);
        nonconditioned=get(handles.nonconditioned,'Value');
        if nonconditioned==1
            hold(handles.axes1,'on');
            plot(time_acq,signal_acquired_original,'--r','linewidth',2,'parent',handles.axes1);
            hold(handles.axes1,'off');
        end
            
    else
        set(handles.text6,'String', 'Frequency (Hz)')
        
        freqscale=-sampl_rate/2:sampl_rate/nsamples:sampl_rate/2-sampl_rate/nsamples;
        fft_signal=abs(fftshift(fft(signal_acquired))/(nsamples/2));
        plot(freqscale,fft_signal,'-b','parent',handles.axes1);
        set(handles.axes1,'xlim',[0 sampl_rate/2],'yscale', 'log','ylim',[5e-7 1e0]);
        nonconditioned=get(handles.nonconditioned,'Value');
        if nonconditioned==1
            hold(handles.axes1,'on');
            fft_signal_original=abs(fftshift(fft(signal_acquired_original))/(nsamples/2));
            plot(freqscale,fft_signal_original,'--r','linewidth',2,'parent',handles.axes1);
            hold(handles.axes1,'off');
        end    
       
    end
end



function nsamples_Callback(hObject, eventdata, handles)
% hObject    handle to nsamples (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
nsamples=str2num(get(handles.nsamples,'String'));
if nsamples > 2048
    set(handles.nsamples,'String',num2str(2048));
elseif nsamples < 32
    set(handles.nbits,'String',num2str(32));
end



% Hints: get(hObject,'String') returns contents of nsamples as text
%        str2double(get(hObject,'String')) returns contents of nsamples as a double


function nbits_Callback(hObject, eventdata, handles)
% hObject    handle to nbits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
bit=str2num(get(handles.nbits,'String'));
if bit > 16
    set(handles.nbits,'String',num2str(16));
elseif bit < 4
    set(handles.nbits,'String',num2str(4));
end
% Hints: get(hObject,'String') returns contents of nbits as text
%        str2double(get(hObject,'String')) returns contents of nbits as a double


function sampl_rate_Callback(hObject, eventdata, handles)
% hObject    handle to sampl_rate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
s_rate=str2num(get(handles.sampl_rate,'String'));
if s_rate > 2048
    set(handles.sampl_rate,'String',num2str(2048));
elseif s_rate < 32
    set(handles.sampl_rate,'String',num2str(32));
end
get(handles.sampl_rate)
% Hints: get(hObject,'String') returns contents of sampl_rate as text
%        str2double(get(hObject,'String')) returns contents of sampl_rate as a double



% --- Executes on selection change in analysis.
function analysis_Callback(hObject, eventdata, handles)
% hObject    handle to analysis (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% Hints: contents = cellstr(get(hObject,'String')) returns analysis contents as cell array
%        contents{get(hObject,'Value')} returns selected item from analysis

% --- Executes on button press in nonconditioned.
function nonconditioned_Callback(hObject, eventdata, handles)
% hObject    handle to nonconditioned (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of nonconditioned


% --- Executes on selection change in range.
function range_Callback(hObject, eventdata, handles)
% hObject    handle to range (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns range contents as cell array
%        contents{get(hObject,'Value')} returns selected item from range
